;   Nokia 1110 96*72  
;>>     2-  .<<
; ,  

.include "m32def.inc"
.def tmp    = r19
.def tmp1   = r20
.def loop   = r21

// LCD
.equ LCD = PORTB // 
.equ dat = PB1 // 
.equ clk = PB0 // 

.CSEG ;Code segment

;Interrupt vectors:
.org 0
	rjmp Init	   ;reset vector

Init:
      cli                  ; 
      ldi tmp,low(RAMEND)  ;  
      out SPL,tmp
      ldi tmp,high(RAMEND) ;  
      out SPH,tmp

      ldi tmp,(1<<clk)|(1<<dat)
      out ddrb,tmp   
      ldi tmp,(1<<clk)|(1<<dat)
      out portb,tmp  

//    
	ldi tmp,0xE2 // Internal reset 
	rcall lcd_cmd
	ldi tmp,0xEB //    
	rcall lcd_cmd
	ldi tmp,0x2F //   
	rcall lcd_cmd
	ldi tmp,0xA1 //  LSB -> MSB 
	rcall lcd_cmd
	ldi tmp,0xA4 //     
	rcall lcd_cmd
	ldi tmp,0xA6 //   
	;ldi tmp,0xA7 //   
	rcall lcd_cmd
	ldi tmp,0xAF //   
	rcall lcd_cmd
 
main:
//****************************************************
	ldi    xl,low (96)    //  
	ldi    xh,high(96)    // 
cl:                  // 
	ldi    tmp,255 
	rcall  out_byte        // 
	sbiw   xl,1            //  
	brne   cl
zz:
rjmp zz 
//*****************************************************

lcd_cmd: //     
	cbi lcd,dat // DAT -> 0 
	sbi lcd,clk // CLK -> 1 
;	nop
;	nop 
	cbi lcd,clk // CLK -> 0 
	rjmp out_byte //  8  
lcd_data: //     
	sbi lcd,dat // DAT -> 1 
	sbi lcd,clk // CLK -> 1  
	cbi lcd,clk // CLK -> 0 
out_byte: //  8    
	ldi loop,8 // bit counter 
out_c: //  
	clc //    
	rol tmp // tmp << 1 
	brcc d_zer //    ,    DATA -> 0 
	sbi lcd,dat //   DATA -> 1 
	rjmp d_one // 
d_zer: // 
	cbi lcd,dat // DATA=0 
d_one: // 
;    nop
	sbi lcd,clk // CLK -> 1  
;	nop
	cbi lcd,clk // CLK -> 0 
	dec loop // 
	brne out_c // 
ret //
